Bug 2017459 - Review Request: raft - C implementation of the Raft consensus protocol
Summary: Review Request: raft - C implementation of the Raft consensus protocol
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Petr Menšík
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 2017476
TreeView+ depends on / blocked
 
Reported: 2021-10-26 14:37 UTC by Reto Gantenbein
Modified: 2021-12-20 01:06 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-12-20 01:06:42 UTC
Type: ---
Embargoed:
pemensik: fedora-review+


Attachments (Terms of Use)

Description Reto Gantenbein 2021-10-26 14:37:12 UTC
Spec URL: https://copr-dist-git.fedorainfracloud.org/cgit/ganto/lxc4/raft.git/plain/raft.spec
SRPM URL: https://linuxmonk.ch/packages/copr/upload/ganto-lxc4/raft-0.11.2-0.1.fc33.src.rpm
Description: C implementation of the Raft consensus protocol
Fedora Account System Username: ganto

This is a dependency required by dqlite a distributed version of sqlite. I'm maintaining this package since a while in the ganto/lxc4 COPR and was asked by various people if this couldn't be added to Fedora official. Here it is.

Comment 1 Petr Menšík 2021-10-26 15:43:02 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig not called in %post and %postun for Fedora 28 and later.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "GNU Lesser General Public License,
     Version 3", "GNU General Public License v2.0 or later", "FSF All
     Permissive License", "MIT License". 212 files have unknown license.
     Detailed output of licensecheck in
     /home/reviewer/fedora/rawhide/2017459-raft/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: Static libraries in -static or -devel subpackage, providing -devel if
     present.
     Note: Package has .a files: raft-static.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Package should not use obsolete m4 macros
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: raft-0.11.2-0.1.fc36.x86_64.rpm
          raft-devel-0.11.2-0.1.fc36.x86_64.rpm
          raft-static-0.11.2-0.1.fc36.x86_64.rpm
          raft-debuginfo-0.11.2-0.1.fc36.x86_64.rpm
          raft-debugsource-0.11.2-0.1.fc36.x86_64.rpm
          raft-0.11.2-0.1.fc36.src.rpm
raft.x86_64: W: name-repeated-in-summary C Raft
raft-devel.x86_64: W: no-documentation
raft-static.x86_64: W: no-documentation
raft.src: W: name-repeated-in-summary C Raft
6 packages and 0 specfiles checked; 0 errors, 4 warnings.




Rpmlint (debuginfo)
-------------------
Checking: raft-debuginfo-0.11.2-0.1.fc36.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Source checksums
----------------
https://github.com/canonical/raft/archive/v0.11.2.tar.gz :
  CHECKSUM(SHA256) this package     : c89fd6a6fa3c9e6d670b74e389b2d028dfd39d1eec2b18661fae73a9bfd6b89d
  CHECKSUM(SHA256) upstream package : c89fd6a6fa3c9e6d670b74e389b2d028dfd39d1eec2b18661fae73a9bfd6b89d


Requires
--------
raft (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    liblz4.so.1()(64bit)
    libuv.so.1()(64bit)
    rtld(GNU_HASH)

raft-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    libraft.so.0()(64bit)
    raft(x86-64)

raft-static (rpmlib, GLIBC filtered):
    raft(x86-64)

raft-debuginfo (rpmlib, GLIBC filtered):

raft-debugsource (rpmlib, GLIBC filtered):



Provides
--------
raft:
    libraft.so.0()(64bit)
    raft
    raft(x86-64)

raft-devel:
    pkgconfig(raft)
    raft-devel
    raft-devel(x86-64)

raft-static:
    raft-static
    raft-static(x86-64)

raft-debuginfo:
    debuginfo(build-id)
    libraft.so.0.0.7-0.11.2-0.1.fc36.x86_64.debug()(64bit)
    raft-debuginfo
    raft-debuginfo(x86-64)

raft-debugsource:
    raft-debugsource
    raft-debugsource(x86-64)



Generated by fedora-review 0.7.6 (b083f91) last change: 2020-11-10
Command line :/usr/bin/fedora-review -b 2017459
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, C/C++, Shell-api
Disabled plugins: fonts, Ocaml, Java, SugarActivity, PHP, Haskell, Python, Perl, R
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 2 Petr Menšík 2021-10-26 15:49:16 UTC
I would use %{URL} in Source0, since the base is common with URL: tag
Source0:        %{URL}/archive/v%{version}.tar.gz

I am not sure what is a reason for -static library. Do you ever need that? I would disable via %bcond_with or remove altogether. All packages in Fedora MUST and should use dynamic library version. Users should usually use shared libraries on the same machine.

Unless you need it for something, I would remove that part [1]. Not mandatory however.

But those are just cosmetic issues. I think the spec is good and can be granted.

[1] https://docs.fedoraproject.org/en-US/packaging-guidelines/#packaging-static-libraries

Comment 3 Petr Menšík 2021-10-26 15:50:08 UTC
Please use fedpkg request-repo to continue.

Comment 4 Reto Gantenbein 2021-10-26 17:02:50 UTC
Thanks for the review:
- I'll drop the static package. It can be re-added quickly if someone really needs it.
- I'll adjust the %{URL} in Source0 as recommended.

Comment 5 Gwyn Ciesla 2021-10-26 18:08:30 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/raft

Comment 6 Reto Gantenbein 2021-10-26 19:57:49 UTC
After some closer look at the package before importing it to src.fedoraproject.org I still found some issues that I'm unsure about:

1. Licensing: When checking the LICENSE file I read "As a special exception to the GNU Lesser General Public License version 3 ("LGPL3"), the copyright holders of this Library give you permission to..." [1] so I guess according to the Fedora License list [2] this would correspond to "LGPLv3 with exceptions" instead of "LGPLv3" that I used so far. If I read correctly I first need to let this approve by legal.org?

2. When checking the content of the source archive I found an extensive documentation [3] that could be built with Sphinx, a benchmark program [4] and some code examples [5] that I completely ignored so far. Do you think I should still add them into separate subpackages? e.g. -docs/-benchmark/-examples? Or add the examples to the docs subpackage?

[1]: https://github.com/canonical/raft/blob/v0.11.2/LICENSE
[2]: https://fedoraproject.org/wiki/Licensing:Main?rd=Licensing#Software_License_List
[3]: https://github.com/canonical/raft/tree/v0.11.2/docs
[4]: https://github.com/canonical/raft/tree/v0.11.2/benchmark
[5]: https://github.com/canonical/raft/tree/v0.11.2/example

Comment 7 Reto Gantenbein 2021-12-05 15:30:37 UTC
Created a separate package raft-benchmark for the os-disk-write and raft-doc for the rendered HTML documentation.

I also got some clarification on the licensing issue via fedora-legal mailing list:

> On 11/24/21 12:09 PM, Jilayne Lovejoy wrote:
> > Fixed! it's LGPL-3.0-only WITH LGPL-3.0-linking-exception
> > see LGPL-3.0-only WITH LGPL-3.0-linking-exception

Will upload the sources now and try to get the package into the Fedora releases.

https://koji.fedoraproject.org/koji/packageinfo?packageID=34666

Comment 8 Fedora Update System 2021-12-11 15:25:21 UTC
FEDORA-2021-9cb0cadda1 has been submitted as an update to Fedora 35. https://bodhi.fedoraproject.org/updates/FEDORA-2021-9cb0cadda1

Comment 9 Fedora Update System 2021-12-12 02:06:04 UTC
FEDORA-2021-9cb0cadda1 has been pushed to the Fedora 35 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-9cb0cadda1 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-9cb0cadda1

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 10 Fedora Update System 2021-12-20 01:06:42 UTC
FEDORA-2021-9cb0cadda1 has been pushed to the Fedora 35 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.